#!/usr/bin/perl

sub parsexpr{
 my $ex = shift(@_);
 my %a;
 if($ex =~ /^\(.*\) >>/){
  $a{$ex} = 1;
  return %a;
 }
 my @z = split(' \+ ', $ex);
 for(my $i=0;$i<=$#z;$i++){
  if($z[$i] =~ /^\d+$/){
   $a{1}=$z[$i];
  }elsif($z[$i] !~ /\*/){
   $a{$z[$i]}=1;
  }else{
   my ($mul, $val2) = split('\*',$z[$i]);
   $a{$val2}=$mul;
  }
 }
 return %a;
}

sub makexpr{
 my $ret="";
 for(my $i=0;$i<=$#_;$i+=2){
  if(length($ret)>0){
   $ret .= " + ";
  }
  $ret .= "$_[$i+1]*$_[$i]";
 }
 return $ret;
}

sub add{
 my $a1 = shift(@_);
 my $a2 = shift(@_);
 
 my %t1 = parsexpr($a1);
 my %t2 = parsexpr($a2);

 foreach $v (keys %t2){
  $t1{$v} = "" . int(sprintf "%d",$t1{$v}) + int(sprintf "%d",$t2{$v});
 }
 return makexpr(%t1);
}

sub substract{
 my $a1 = shift(@_);
 my $a2 = shift(@_);

 my %t1 = parsexpr($a1);
 my %t2 = parsexpr($a2);

 foreach $v (keys %t2){
  $t1{$v} = "".int(sprintf "%d",$t1{$v}) - int(sprintf "%d",$t2{$v});
 }
 return makexpr(%t1);
}

sub mult{
 my $a1 = shift(@_);
 my $a2 = shift(@_);
 
 my %t1 = parsexpr($a1);

 foreach $v (keys %t1){
  $t1{$v} = "". (int($t1{$v}) * int($a2));
 }
 return makexpr(%t1);
}

sub termlen{
 my $val = shift(@_);
 my $pos;
 my $state = 0;
 for($pos = 0; $pos < length($val) - 1; $pos++){
  my $v = substr($val,$pos,1);
  if($v eq "("){$state++;}
  if($v eq ")"){$state--;}
  if($pos > 0 && $state == 0){
   return $pos;
  }
 }
 return -1;
}
sub calculate{
 my $val = shift(@_);
 my $p = termlen($val);

 if($val =~ /^(.*) >> ([^()]+)$/){
  my $v = calculate($1);
  return "($v) >> $2";
 }
 if($p != -1 && $p != 1){
  my $a0 = substr($val, 0, $p+1);
  my $op = substr($val, $p+2,1);
  my $a1 = substr($val, $p+4);
  $a0 = calculate($a0);
  $a1 = calculate($a1);
  if($op eq "-"){
   return substract($a0, $a1);
  }
  if($op eq "+"){
   return add($a0, $a1);
  }
  if($op eq "*"){
   return mult($a0, $a1);
  }
  print "!!!!!!!!!! $op\n";
 }
 if($val =~ /^\(.*\)$/){
  return calculate(substr($val,1,length($val)-2));
 }
 return "$val";
}
while(<>){
 chomp;
# print "Was: $_\n";
 my ($lv, $rv) = split(" = ");
 $rv = calculate($rv);
 print "$lv = $rv\n";
}
